"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const error_1 = require("./error");
function isEqual(target, value, name = 'Value') {
    if (target !== value)
        throw new error_1.ValidationError(name, `value: ${value} does not equal taget value: ${target}`);
}
exports.isEqual = isEqual;
function isBoolean(value, name = 'Value') {
    if (typeof value !== 'boolean')
        throw new Error(`${name} is not a boolean.`);
}
exports.isBoolean = isBoolean;
function isString(value, name = 'Value') {
    if (typeof value !== 'string')
        throw new Error(`${name} is not a string.`);
}
exports.isString = isString;
function isNumber(value, name = 'Value') {
    if (Number.isNaN(value))
        throw new Error(`${name} is NaN.`);
}
exports.isNumber = isNumber;
function isInt(value, name = 'Value') {
    if (Number.isNaN(value))
        throw new Error(`${name} is not an integer.`);
}
exports.isInt = isInt;
function isFloat(value, name = 'Value') {
    if (Number.isNaN(value))
        throw new Error(`${name} is not a float.`);
}
exports.isFloat = isFloat;
function isPositive(value, name = 'Value') {
    if (value <= 0)
        throw new Error(`${name} is <= 0, should be > 0.`);
}
exports.isPositive = isPositive;
function isArray(value, name = 'value') {
    if (!Array.isArray(value))
        throw new Error(`${name} is not an array`);
}
exports.isArray = isArray;
function isNull(value, name = 'Value') {
    if (value !== null)
        throw new Error(`${name} is not null`);
}
exports.isNull = isNull;
function isNonNullObject(value, name = 'Value') {
    if (typeof value !== 'object' || value === null)
        throw new Error(`${name} is not an object or null`);
}
exports.isNonNullObject = isNonNullObject;
function isUndefined(value, name = 'Value') {
    if (typeof value !== 'undefined')
        throw new Error(`${name} is not undefined.`);
}
exports.isUndefined = isUndefined;
function isDefined(value, name = 'Value') {
    if (typeof value === 'undefined')
        throw new Error(`${name} is undefined.`);
}
exports.isDefined = isDefined;
function isRegEx(regEx, value, name = 'Value') {
    if (!regEx.test(value))
        throw new Error(`${name} does not match RegExp.`);
}
exports.isRegEx = isRegEx;
//# sourceMappingURL=assertions.js.map