"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sym = require("./symbols");
const common_1 = require("./common");
function Type(ctor) {
    if (common_1.nullOrUndef(ctor) || common_1.nullOrUndef(ctor.prototype))
        throw new Error('Schema error, not a valid type.');
    let result = (() => { });
    result[sym.Validator] = sym.TypeValidator;
    result[sym.TypeValidator] = ctor.prototype.constructor.name;
    return result;
}
exports.Type = Type;
function Options(validators) {
    let result = (() => { });
    result[sym.Validator] = sym.OptionsValidator;
    result[sym.OptionsValidator] = validators;
    return result;
}
exports.Options = Options;
function Optional(validator) {
    return Options([validator, undefined]);
}
exports.Optional = Optional;
function Nullable(validator) {
    return Options([validator, null]);
}
exports.Nullable = Nullable;
function Validator(method) {
    const result = (() => { });
    result[sym.Validator] = sym.CustomValidator;
    result[sym.CustomValidator] = method;
    return result;
}
exports.Validator = Validator;
//# sourceMappingURL=validators.js.map